'Imports System.IO
'Imports System.IO.File
'Imports System.Runtime.InteropServices
Imports Microsoft.VisualBasic

Public Class Form1

    Private Const NUM_VALUES As Integer = 10
    Const INTEGER_SIZE As Integer = 4

    Private m_TextBoxes() As TextBox

    ' Load saved values.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        m_TextBoxes = New TextBox() {TextBox1, TextBox2, TextBox3, TextBox4, TextBox5, TextBox6, TextBox7, TextBox8, TextBox9, TextBox10}

        ' Get the file name.
        Dim file_name As String = GetFileName()

        ' See if the file exists.
        If System.IO.File.Exists(file_name) Then
            ' Open the file.
            Dim file_num As Integer = FreeFile()
            FileOpen(file_num, file_name, _
                OpenMode.Binary, OpenAccess.Read, _
                OpenShare.Shared, INTEGER_SIZE)

            ' Read the array.
            Dim integers(NUM_VALUES - 1) As Integer
            FileGet(file_num, integers)

            ' Close the file.
            FileClose(file_num)

            ' Display values.
            For i As Integer = 0 To NUM_VALUES - 1
                m_TextBoxes(i).Text = integers(i).ToString()
            Next i
        End If
    End Sub

    ' Save the current values.
    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        ' Get the file name.
        Dim file_name As String = GetFileName()

        ' Create the file.
        Dim file_num As Integer = FreeFile()
        FileOpen(file_num, file_name, _
            OpenMode.Binary, OpenAccess.Write, _
            OpenShare.Shared, INTEGER_SIZE)

        ' Write the array.
        Dim integers(NUM_VALUES - 1) As Integer
        For i As Integer = 0 To NUM_VALUES - 1
            integers(i) = Val(m_TextBoxes(i).Text)
        Next i
        FilePut(file_num, integers)

        ' Close the file.
        FileClose(file_num)
    End Sub

    Private Function GetFileName() As String
        Dim file_name As String = Application.StartupPath
        If file_name.EndsWith("\bin\Debug") Then file_name = file_name.Substring(0, file_name.Length - 10)
        If Not file_name.EndsWith("\") Then file_name &= "\"
        Return file_name & "numbers.dat"
    End Function
End Class
